const http = require('http');

const process = (operators, bridges, words, generators, utterances, objects, key, flatten=null) =>

  new Promise( (resolve, reject) => {
    var data = { operators, bridges, words, generators, utterances, objects, key, version: '3'};
    if (flatten) {
      data["flatten"] = flatten;
    }
    data = JSON.stringify(data);

    const options = {
      hostname: '184.67.27.82',
      port: 5000,
      path: '/process',
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'Content-Length': data.length
      }
    }

    const req = http.request(options, (res) => {
      console.log(`statusCode: ${res.statusCode}`)

      res.on('data', (d) => {
        console.log('in DATA');
        console.log(d.toString())
        if (res.statusCode == 200) {
          resolve(d.toString())
        } else {
          reject(d.toString())
        }
      })
    })

    req.on('error', (error) => {
        console.log('in ERROR');
      const message = `Error from server ${error}.`;
      reject(message)
    })

    req.write(data)
    req.end()
  });

module.exports = { process }
